Kerneｌ#exec(cmdname, arg1, ...) passes arg1 that is encoded strangely on Japanese Windows

10/14/2016 01:06 PM - dogatana (Toshihiko Ichida)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.3.0p0 (2015-12-25 revision

53290) [i386-mingw32] 

Backport: 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3:

UNKNOWN

Description

Kernel#exec(cmdname, arg1, ...) 形式でプログラムを呼び出す際、argが日本語を含んでいると

化けた文字列が渡されます。

同じ内容を Kernel#excec(cmdline) 形式で呼び出すと問題は発生しません。

直接呼び出す場合は問題なし

          

> ruby test.rb あ                                    

arg: あ, enc: Windows-31J, bytes: 82-a0             

 cmdline だと問題なし

> irb                                               

irb(main):001:0> Kernel.exec 'ruby test.rb あ'       

arg: あ, enc: Windows-31J, bytes: 82-a0             

 cmdname, arg1 だとarg1が文字化けしている。

> irb                                               

irb(main):001:0> Kernel.exec 'ruby', 'test.rb', 'あ' 

arg: 縺・, enc: Windows-31J, bytes: e3-81-81-45      

 bunlder が Kernel#excec(cmdname, arg1, ...)形式を利用しているため、

bundle exec mygemprogram 引数

 として作成中にgemを実行する場合、漢字を含む引数が正しく受け取れ

なくなっています。

Associated revisions

Revision 5d4309d068f731a17be791b0dfe6e484a39c25c8 - 10/14/2016 03:54 PM - nobu (Nobuyoshi Nakada)

process.c: use uaspawn

process.c (proc_exec_cmd): use UTF-8 version aspawn.

[ruby-dev:49838] [Bug #12841]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56424 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 5d4309d0 - 10/14/2016 03:54 PM - nobu (Nobuyoshi Nakada)

process.c: use uaspawn

process.c (proc_exec_cmd): use UTF-8 version aspawn.

[ruby-dev:49838] [Bug #12841]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56424 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 10/14/2016 03:54 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed
Applied in changeset r56424.

process.c: use uaspawn

process.c (proc_exec_cmd): use UTF-8 version aspawn.

[ruby-dev:49838] [Bug #12841]

Files

test.rb 111 Bytes 10/14/2016 dogatana (Toshihiko Ichida)
